
#include "lvgl.h"
#include "lv_example_arc.h"

/*************** Example 1 ****************************/
void lv_example_arc_1(void)
{
  /*Create an Arc*/
  lv_obj_t* arc = lv_arc_create(lv_scr_act()); //在当前显示画面中申请一个arc对象
  lv_obj_set_size(arc, 150, 150);              //设置arc对象: 宽150个像素点,高150个像素点
  lv_arc_set_rotation(arc, 180);               //设置arc控件滑条起始点位置
  lv_arc_set_bg_angles(arc, 0, 360);           //设置弧形控件背景部分的度数范围
  lv_arc_set_range(arc, 0, 360);               //设置弧形控件显示部分数值范围
  lv_arc_set_value(arc, 90);                   //设置弧形控件显示部分的数值
  lv_obj_center(arc);                          //居中显示
}


/*************** Example 2 ****************************/
static void set_angle(void * obj, int32_t v)
{
  lv_arc_set_value((lv_obj_t*)obj, v);
}

/**
   Create an arc which acts as a loader.
*/
void lv_example_arc_2(void)
{

    static lv_style_t style_indic_pr;
    lv_style_init(&style_indic_pr);
    lv_style_set_shadow_color(&style_indic_pr, lv_palette_main(LV_PALETTE_RED));
    lv_style_set_shadow_width(&style_indic_pr, 10);
    lv_style_set_shadow_spread(&style_indic_pr, 3);
  
      static lv_style_t style_indic;
    lv_style_init(&style_indic);
    lv_style_set_bg_color(&style_indic, lv_palette_lighten(LV_PALETTE_RED, 3));
    lv_style_set_bg_grad_color(&style_indic, lv_palette_main(LV_PALETTE_RED));
    lv_style_set_bg_grad_dir(&style_indic, LV_GRAD_DIR_HOR);
    
  /*Create an Arc*/
  lv_obj_t * arc = lv_arc_create(lv_scr_act());
    lv_obj_add_style(arc, &style_indic, LV_PART_INDICATOR);
    lv_obj_add_style(arc, &style_indic_pr, LV_PART_INDICATOR | LV_STATE_PRESSED);
  lv_obj_set_size(arc, 50, 50); 
  lv_arc_set_rotation(arc, 140);
  lv_arc_set_bg_angles(arc, 0, 265);
  lv_obj_remove_style(arc, NULL, LV_PART_KNOB);   /*Be sure the knob is not displayed*/
  lv_obj_clear_flag(arc, LV_OBJ_FLAG_CLICKABLE);  /*To not allow adjusting by click*/
  lv_obj_center(arc);


lv_arc_set_value(arc, 10*2);/* code */

  lv_anim_t a;
  lv_anim_init(&a);
  lv_anim_set_var(&a, arc);
 // lv_anim_set_exec_cb(&a, set_angle);
  lv_anim_set_time(&a, 1000);
  lv_anim_set_repeat_count(&a, LV_ANIM_REPEAT_INFINITE);    /*Just for the demo*/
  lv_anim_set_repeat_delay(&a, 500);
  lv_anim_set_values(&a, 0, 100);
  lv_anim_start(&a);
  



    lv_obj_t * arc2 = lv_arc_create(lv_scr_act());
  lv_obj_set_size(arc2, 70, 70); 
  lv_arc_set_rotation(arc2, 140);
  lv_arc_set_bg_angles(arc2, 0, 265);
 
  lv_obj_remove_style(arc2, NULL, LV_PART_KNOB);   /*Be sure the knob is not displayed*/
  lv_obj_clear_flag(arc2, LV_OBJ_FLAG_CLICKABLE);  /*To not allow adjusting by click*/
  lv_obj_center(arc2);

lv_arc_set_value(arc2, 80);/* code */

  
  lv_anim_init(&a);
  lv_anim_set_var(&a, arc2);
 // lv_anim_set_exec_cb(&a, set_angle);
  lv_anim_set_time(&a, 1000);
  lv_anim_set_repeat_count(&a, LV_ANIM_REPEAT_INFINITE);    /*Just for the demo*/
  lv_anim_set_repeat_delay(&a, 500);
  lv_anim_set_values(&a, 0, 100);
  lv_anim_start(&a);
  
}



  


